# wxJoystick Class Reference
[Miscellaneous]

`#include <wx/joystick.h>`

Inheritance diagram for wxJoystick:
[legend]

## Detailed Description

wxJoystick allows an application to control one or more joysticks.

##

Library: wxAdvanced

Category: Miscellaneous

See also:
  wxJoystickEvent

## Public Member Functions
| wxJoystick (int joystick=wxJOYSTICK1)
| Constructor.
virtual | ~wxJoystick ()
| Destroys the wxJoystick object.
int | GetButtonState () const
| Returns the state of the joystick buttons.
bool | GetButtonState (unsigned int id) const
| Returns the state of the specified joystick button.
int | GetManufacturerId () const
| Returns the manufacturer id.
int | GetMovementThreshold () const
| Returns the movement threshold, the number of steps outside which the joystick is deemed to have moved.
int | GetNumberAxes () const
| Returns the number of axes for this joystick.
int | GetNumberButtons () const
| Returns the number of buttons for this joystick.
int | GetPOVCTSPosition () const
| Returns the point-of-view position, expressed in continuous, one-hundredth of a degree units.
int | GetPOVPosition () const
| Returns the point-of-view position, expressed in continuous, one-hundredth of a degree units, but limited to return 0, 9000, 18000 or 27000.
int | GetPollingMax () const
| Returns the maximum polling frequency.
int | GetPollingMin () const
| Returns the minimum polling frequency.
wxPoint | GetPosition () const
| Returns the x, y position of the joystick.
int | GetPosition (unsigned int axis) const
| Returns the position of the specified joystick axis.
int | GetProductId () const
| Returns the product id for the joystick.
wxString | GetProductName () const
| Returns the product name for the joystick.
int | GetRudderMax () const
| Returns the maximum rudder position.
int | GetRudderMin () const
| Returns the minimum rudder position.
int | GetRudderPosition () const
| Returns the rudder position.
int | GetUMax () const
| Returns the maximum U position.
int | GetUMin () const
| Returns the minimum U position.
int | GetUPosition () const
| Gets the position of the fifth axis of the joystick, if it exists.
int | GetVMax () const
| Returns the maximum V position.
int | GetVMin () const
| Returns the minimum V position.
int | GetVPosition () const
| Gets the position of the sixth axis of the joystick, if it exists.
int | GetXMax () const
| Returns the maximum x position.
int | GetXMin () const
| Returns the minimum x position.
int | GetYMax () const
| Returns the maximum y position.
int | GetYMin () const
| Returns the minimum y position.
int | GetZMax () const
| Returns the maximum z position.
int | GetZMin () const
| Returns the minimum z position.
int | GetZPosition () const
| Returns the z position of the joystick.
bool | HasPOV () const
| Returns true if the joystick has a point of view control.
bool | HasPOV4Dir () const
| Returns true if the joystick point-of-view supports discrete values (centered, forward, backward, left, and right).
bool | HasPOVCTS () const
| Returns true if the joystick point-of-view supports continuous degree bearings.
bool | HasRudder () const
| Returns true if there is a rudder attached to the computer.
bool | HasU () const
| Returns true if the joystick has a U axis.
bool | HasV () const
| Returns true if the joystick has a V axis.
bool | HasZ () const
| Returns true if the joystick has a Z axis.
bool | IsOk () const
| Returns true if the joystick is functioning.
bool | ReleaseCapture ()
| Releases the capture set by SetCapture.
bool | SetCapture (wxWindow *win, int pollingFreq=0)
| Sets the capture to direct joystick events to win.
void | SetMovementThreshold (int threshold)
| Sets the movement threshold, the number of steps outside which the joystick is deemed to have moved.
## Static Public Member Functions
static int | GetNumberJoysticks ()
| Returns the number of joysticks currently attached to the computer.

List of all members.

## Constructor & Destructor Documentation

wxJoystick::wxJoystick | ( | int | joystick = `wxJOYSTICK1` | ) |

Constructor.

joystick may be one of wxJOYSTICK1, wxJOYSTICK2, indicating the joystick controller of interest.

virtual wxJoystick::~wxJoystick | ( |  | ) | `[virtual]`

Destroys the wxJoystick object.

## Member Function Documentation

bool wxJoystick::GetButtonState | ( | unsigned int | id | ) | const

Returns the state of the specified joystick button.

Parameters:

  | id | The button id to report, from 0 to GetNumberButtons() - 1

int wxJoystick::GetButtonState | ( |  | ) | const

Returns the state of the joystick buttons.

Every button is mapped to a single bit in the returned integer, with the first button being mapped to the least significant bit, and so on.

A bitlist of wxJOY_BUTTONn identifiers, where n is 1, 2, 3 or 4 is available for historical reasons.

int wxJoystick::GetManufacturerId | ( |  | ) | const

Returns the manufacturer id.

int wxJoystick::GetMovementThreshold | ( |  | ) | const

Returns the movement threshold, the number of steps outside which the joystick is deemed to have moved.

int wxJoystick::GetNumberAxes | ( |  | ) | const

Returns the number of axes for this joystick.

int wxJoystick::GetNumberButtons | ( |  | ) | const

Returns the number of buttons for this joystick.

static int wxJoystick::GetNumberJoysticks | ( |  | ) | `[static]`

Returns the number of joysticks currently attached to the computer.

int wxJoystick::GetPollingMax | ( |  | ) | const

Returns the maximum polling frequency.

int wxJoystick::GetPollingMin | ( |  | ) | const

Returns the minimum polling frequency.

int wxJoystick::GetPosition | ( | unsigned int | axis | ) | const

Returns the position of the specified joystick axis.

Parameters:

  | axis | The joystick axis to report, from 0 to GetNumberAxes() - 1.

wxPoint wxJoystick::GetPosition | ( |  | ) | const

Returns the x, y position of the joystick.

int wxJoystick::GetPOVCTSPosition | ( |  | ) | const

Returns the point-of-view position, expressed in continuous, one-hundredth of a degree units.

Returns -1 on error.

int wxJoystick::GetPOVPosition | ( |  | ) | const

Returns the point-of-view position, expressed in continuous, one-hundredth of a degree units, but limited to return 0, 9000, 18000 or 27000.

Returns -1 on error.

int wxJoystick::GetProductId | ( |  | ) | const

Returns the product id for the joystick.

wxString wxJoystick::GetProductName | ( |  | ) | const

Returns the product name for the joystick.

int wxJoystick::GetRudderMax | ( |  | ) | const

Returns the maximum rudder position.

int wxJoystick::GetRudderMin | ( |  | ) | const

Returns the minimum rudder position.

int wxJoystick::GetRudderPosition | ( |  | ) | const

Returns the rudder position.

int wxJoystick::GetUMax | ( |  | ) | const

Returns the maximum U position.

int wxJoystick::GetUMin | ( |  | ) | const

Returns the minimum U position.

int wxJoystick::GetUPosition | ( |  | ) | const

Gets the position of the fifth axis of the joystick, if it exists.

int wxJoystick::GetVMax | ( |  | ) | const

Returns the maximum V position.

int wxJoystick::GetVMin | ( |  | ) | const

Returns the minimum V position.

int wxJoystick::GetVPosition | ( |  | ) | const

Gets the position of the sixth axis of the joystick, if it exists.

int wxJoystick::GetXMax | ( |  | ) | const

Returns the maximum x position.

int wxJoystick::GetXMin | ( |  | ) | const

Returns the minimum x position.

int wxJoystick::GetYMax | ( |  | ) | const

Returns the maximum y position.

int wxJoystick::GetYMin | ( |  | ) | const

Returns the minimum y position.

int wxJoystick::GetZMax | ( |  | ) | const

Returns the maximum z position.

int wxJoystick::GetZMin | ( |  | ) | const

Returns the minimum z position.

int wxJoystick::GetZPosition | ( |  | ) | const

Returns the z position of the joystick.

bool wxJoystick::HasPOV | ( |  | ) | const

Returns true if the joystick has a point of view control.

bool wxJoystick::HasPOV4Dir | ( |  | ) | const

Returns true if the joystick point-of-view supports discrete values (centered, forward, backward, left, and right).

bool wxJoystick::HasPOVCTS | ( |  | ) | const

Returns true if the joystick point-of-view supports continuous degree bearings.

bool wxJoystick::HasRudder | ( |  | ) | const

Returns true if there is a rudder attached to the computer.

bool wxJoystick::HasU | ( |  | ) | const

Returns true if the joystick has a U axis.

bool wxJoystick::HasV | ( |  | ) | const

Returns true if the joystick has a V axis.

bool wxJoystick::HasZ | ( |  | ) | const

Returns true if the joystick has a Z axis.

bool wxJoystick::IsOk | ( |  | ) | const

Returns true if the joystick is functioning.

bool wxJoystick::ReleaseCapture | ( |  | ) |

Releases the capture set by SetCapture.

Returns:
  true if the capture release succeeded.

See also:
  SetCapture(), wxJoystickEvent

bool wxJoystick::SetCapture | ( | wxWindow * | win,
|  | int | pollingFreq = `0` |
| ) |  |  |

Sets the capture to direct joystick events to win.

Parameters:

  | win | The window that will receive joystick events.
  | pollingFreq | If zero, movement events are sent when above the threshold. If greater than zero, events are received every pollingFreq milliseconds.

Returns:
  true if the capture succeeded.

See also:
  ReleaseCapture(), wxJoystickEvent

void wxJoystick::SetMovementThreshold | ( | int | threshold | ) |

Sets the movement threshold, the number of steps outside which the joystick is deemed to have moved.

|  | [ top ]